/*	
	@author Rafal "DarkGL" Wiecek 
	@site www.darkgl.amxx.pl
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>

#define PLUGIN	"Anti-Developer"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

#define MAX 32

new iMaxFrames		=	130;
new iMaxWarnings	=	3;

new iUserWarnings[ MAX + 1 ];

public plugin_init(){
	
	register_plugin( PLUGIN, VERSION, AUTHOR );
	
	register_cvar( "anti_developer_force" , "1"  );
	register_cvar( "anti_developer_interval" , "1.0" );
	
	register_cvar( "anti_developer_max_frames" , "130" );
	register_cvar( "anti_developer_warnings" , "3" );
}

public plugin_cfg(){
	
	if( get_cvar_num( "anti_developer_force" ) ){
		set_task( get_cvar_float( "anti_developer_interval" ) , "forceDeveloper" , .flags = "b" );
	}
	
	iMaxFrames		=	get_cvar_num( "anti_developer_max_frames" );
	iMaxWarnings	=	get_cvar_num( "anti_developer_warnings" );
}

public forceDeveloper(){
	client_cmd( 0 , "developer 0" );
}

public client_connect( id ){
	iUserWarnings[ id ]	=	0;
}

public client_PreThink( id ){
	
	if( !is_user_alive( id ) )	return ;
	
	static Float: userTime[ MAX + 1 ];
	
	new iFrames	= floatround( 1.0 / ( get_gametime() - userTime[ id ] ) );
	
	if( iFrames > iMaxFrames ){
		
		iUserWarnings[ id ]++;
		
		if( iUserWarnings[ id ] >= iMaxWarnings ){
			new szName[ 64 ];
			
			get_user_name( id , szName , charsmax( szName ) );
			
			iUserWarnings[ id ]	=	0;
			
			user_kill( id );
			
			client_print( 0 , print_chat, "[AntiDeveloper] %s zostal zabity poniewaz przekroczyl dozwolona liczbe FPS", szName );
			
		}
	}
	
	userTime[ id ]	=	get_gametime();
}